#pragma once

#include "screen.h"

// Display

class CDisplay : public IDisplay
{
public :
   CDisplay ();
   virtual ~CDisplay ();

   virtual void Display() {};
   virtual bool AFrameIsReady  () {return true;};
   virtual void Init (HINSTANCE hInstance, HWND hWnd, HWND hToolbar){};
   virtual void Config () {};
   virtual TCHAR* GetInformations () { return _T("TCL GDI");};
   virtual bool Available (HWND hWnd) { return true;};
   virtual int GetWidth () ;
   virtual int GetHeight () ;
   virtual void SetRasterline ( unsigned int *col, int y, int nbPixels );
   virtual void HSync () ;
   virtual void VSync () ;
   virtual void StartSync();
   virtual void WaitVbl () ;
   virtual int* GetVideoBuffer (int y) ;
   virtual void Reset () ;
   virtual void Screenshot (){};
   virtual bool IsDisplayed () { return m_bShow;};
   virtual void FullScreenToggle (){};
   virtual void ForceFullScreen (bool bSetFullScreen ){}
   virtual void WindowChanged (int x, int y, int xIn, int yIn, int width, int height){};
   virtual bool SetSyncWithVBL ( int speed ){return false; };
   virtual bool IsWaitHandled() { return false; };
   virtual bool GetBlackScreenInterval () { return false ;};
   virtual void SetBlackScreenInterval (bool bBS) { };

   void Init ();
   void Show ( bool bShow );
   virtual void StopMessaging  ( bool bStop ){m_bStop=bStop;};

   virtual void SetSize (SizeEnum size){};
   virtual SizeEnum  GetSize () { return S_Standard; };

   static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

   virtual void ResetDragnDropDisplay () {};
   virtual void SetDragnDropDisplay  ( int type ){};
   virtual void SetCurrentPart ( POINT pt ){};
   virtual int GetDnDPart () { return 0;};

protected:
   bool m_bShow;
   bool m_bStop; 
   // Displayed window : 
   int m_X, m_Y;
   int m_Width;
   int m_Height;

   HWND        m_hWnd;
   HDC         m_hwndDC;
   HDC         m_MemDC;
   HBITMAP     m_Bitmap;
   HBITMAP     m_iOldBmp;
   HBITMAP     m_iBitmap;
   Bitmap*     m_BmpMem;
   BITMAPINFO  bi24BitInfo; // We set this up to grab what we want
   int *       bBytes ;

};
